import time
import yaml
import re
from prometheus_client import start_http_server
from scanners.db_mod import DbScan
from scanners.onos_stats_mod import OnosStatsScan
from scanners.flows_stats_mod import OnosFlowsScan
from scanners.voltha_devices_mod import VolthaDevicesScan
from scanners.devices_stats_mod import OnosDevicesScan
from scanners.links_stats_mod import  OnosLinksScan
from scanners.alarms_stats_mod import OnosAlarmsScan

config = {}


def scanner_distributor(scanners):
    for scanner in scanners:
        if scanner['enabled']:
            if scanner['name'] == 'db':
                DbScan.get_data()
            if scanner['name'] == 'onos_stats':
                OnosStatsScan.get_data()
            if scanner['name'] == 'flows_stats':
                OnosFlowsScan.get_data()
            if scanner['name'] == 'voltha_devices_stats':
                VolthaDevicesScan.get_data()
            if scanner['name'] == 'links_stats':
                OnosLinksScan.get_data()
            if scanner['name'] == 'devices_stats':
                OnosDevicesScan.get_data()
            if scanner['name'] == 'alarms_stats':
                OnosAlarmsScan.get_data()


def scanner_init(scanners):
    for scanner in scanners:
        if scanner['enabled']:
            if scanner['name'] == 'db':
                DbScan.create_scheme(scanner)
            if scanner['name'] == 'onos_stats':
                OnosStatsScan.create_scheme(scanner)
            if scanner['name'] == 'flows_stats':
                OnosFlowsScan.create_scheme(scanner)
            if scanner['name'] == 'voltha_devices_stats':
                VolthaDevicesScan.create_scheme(scanner)
            if scanner['name'] == 'links_stats':
                OnosLinksScan.create_scheme(scanner)
            if scanner['name'] == 'devices_stats':
                OnosDevicesScan.create_scheme(scanner)
            if scanner['name'] == 'alarms_stats':
                OnosAlarmsScan.create_scheme(scanner)


if __name__ == '__main__':
    stream = file('./agent.yaml', 'r')
    yaml.add_constructor('!regexp', lambda l, n: re.compile(l.construct_scalar(n)))
    config = yaml.load(stream)
    print config
    # Start up the server to expose the metrics.
    start_http_server(config['server']['port'])

    scanner_init(config['scanners'])
    try:
        while True:
            scanner_distributor(config['scanners'])
            time.sleep(config['refresh_period'])
            print 'Scanning....'
    except KeyboardInterrupt: