from prometheus_client import Gauge
import requests
from requests import auth
import time


class OnosAlarmsScan:
    scheme = {}
    config = {}
    db = {}

    def __init__(self):
        pass

    @staticmethod
    def create_scheme(config):
        OnosAlarmsScan.config = config
        OnosAlarmsScan.scheme = {}
        OnosAlarmsScan.scheme['onos_alarm_deviceId'] = Gauge('onos_alarm_deviceId', 'onos_alarm_deviceId', ['id', 'deviceId'])
        OnosAlarmsScan.scheme['onos_alarm_description'] = Gauge('onos_alarm_description', 'onos_alarm_description', ['id','description'])
        OnosAlarmsScan.scheme['onos_alarm_timeRaised'] = Gauge('onos_alarm_timeRaised', 'onos_alarm_timeRaised', ['id', 'timeRaised'])
        OnosAlarmsScan.scheme['onos_alarm_severity'] = Gauge('onos_alarm_severity', 'onos_alarm_severity', ['id', 'severity'])

    @staticmethod
    def get_data():

        try:
            response = requests.get(OnosAlarmsScan.config['uri'], auth=auth.HTTPBasicAuth(OnosAlarmsScan.config['user'], OnosAlarmsScan.config['password']), timeout=1)
            body =  response.json()['alarms']
            #print body
            for id in body:
                #a=id['lastUpdate']
                #b=time.time()
                #seconds=b-int(a)
                #minutes=seconds // 60 % 60
                epoch=id['timeRaised']
                if(id['severity']=='MAJOR'):
                   a=1
                else:
                   a=0
                timeRaised=time.strftime("%a, %d %b %Y %H:%M:%S %Z", time.localtime(float(epoch)))
                OnosAlarmsScan.scheme['onos_alarm_deviceId'].labels(id=id['id'], deviceId=id['deviceId'])
                OnosAlarmsScan.scheme['onos_alarm_description'].labels(id=id['id'],description=id['description'])
                OnosAlarmsScan.scheme['onos_alarm_timeRaised'].labels(id=id['id'], timeRaised=timeRaised).set(id['timeRaised'])
                OnosAlarmsScan.scheme['onos_alarm_severity'].labels(id=id['id'],severity=id['severity']).set(a)
        
        except requests.exceptions.Timeout:
            print "Onos connecion error"
        print 'Onos Alarms Scan'