from prometheus_client import Gauge
import requests
from requests import auth
import time


class OnosDevicesScan:
    scheme = {}
    config = {}
    db = {}

    def __init__(self):
        pass

    @staticmethod
    def create_scheme(config):
        OnosDevicesScan.config = config
        OnosDevicesScan.scheme = {}
        OnosDevicesScan.scheme['onos_available'] = Gauge('onos_available', 'onos_available', ['id', 'available'])
        OnosDevicesScan.scheme['onos_lastUpdate'] = Gauge('onos_lastUpdate', 'onos_lastUpdate', ['id','lastUpdate'])

    @staticmethod
    def get_data():

        try:
            response = requests.get(OnosDevicesScan.config['uri'], auth=auth.HTTPBasicAuth(OnosDevicesScan.config['user'], OnosDevicesScan.config['password']), timeout=1)
            body =  response.json()['devices']
            #print body
            for id in body:
                #a=id['lastUpdate']
                #b=time.time()
                #seconds=b-int(a)
                #minutes=seconds // 60 % 60
                epoch=id['lastUpdate']
                if(id['available']=='true'):
                   a=1
                else:
                   a=0
                lastUpdate=time.strftime("%a, %d %b %Y %H:%M:%S %Z", time.localtime(float(epoch)))
                OnosDevicesScan.scheme['onos_available'].labels(id=id['id'], available=id['available']).set(a)
                OnosDevicesScan.scheme['onos_lastUpdate'].labels(id=id['id'],lastUpdate=lastUpdate).set(id['lastUpdate'])
        
        except requests.exceptions.Timeout:
            print "Onos connecion error"
        print 'Onos Stats Scan'