from prometheus_client import Gauge
import requests
from requests import auth


class OnosFlowsScan:
    scheme = {}
    config = {}
    db = {}

    def __init__(self):
        pass

    @staticmethod
    def create_scheme(config):
        OnosFlowsScan.config = config
        OnosFlowsScan.scheme = {}
        OnosFlowsScan.scheme['onos_flows_state'] = Gauge('onos_flows_state', 'onos_state', ['id','state'])
        OnosFlowsScan.scheme['onos_flows_packets'] = Gauge('onos_flows_packets', 'onos_packets', ['id'])
        OnosFlowsScan.scheme['onos_flows_bytes'] = Gauge('onos_flows_bytes', 'onos_bytes', ['id'])



    @staticmethod
    def get_data():
        try:
            response = requests.get(OnosFlowsScan.config['uri'], auth=auth.HTTPBasicAuth(OnosFlowsScan.config['user'], OnosFlowsScan.config['password']), timeout=1)
            body =  response.json()['flows']
            #print body
            a=0
            for id in body:
                if (id['state']=="ADDED"):
                        a=1
                else:
                        a=0
                OnosFlowsScan.scheme['onos_flows_state'].labels(id=id['id'], state=id['state']).set(a)
                OnosFlowsScan.scheme['onos_flows_packets'].labels(id=id['id']).set(id['packets'])
                OnosFlowsScan.scheme['onos_flows_bytes'].labels(id=id['id']).set(id['bytes'])



        except requests.exceptions.Timeout:
            print "Onos connecion error"
        print 'Onos Flows Scan'