from prometheus_client import Gauge
import requests
from requests import auth


class OnosStatsScan:
    scheme = {}
    config = {}
    db = {}

    def __init__(self):
        pass

    @staticmethod
    def create_scheme(config):
        OnosStatsScan.config = config
        OnosStatsScan.scheme = {}
        OnosStatsScan.scheme['onos_packetsReceived'] = Gauge('onos_packetsReceived', 'onos_packetsReceived', ['device', 'port'])
        OnosStatsScan.scheme['onos_packetsSent'] = Gauge('onos_packetsSent', 'onos_packetsSent', ['device', 'port'])
        OnosStatsScan.scheme['onos_bytesReceived'] = Gauge('onos_bytesReceived', 'onos_bytesReceived', ['device', 'port'])
        OnosStatsScan.scheme['onos_bytesSent'] = Gauge('onos_bytesSent', 'onos_bytesSent', ['device', 'port'])
        OnosStatsScan.scheme['onos_packetsRxDropped'] = Gauge('onos_packetsRxDropped', 'onos_packetsRxDropped', ['device', 'port'])
        OnosStatsScan.scheme['onos_packetsTxDropped'] = Gauge('onos_packetsTxDropped', 'onos_packetsTxDropped', ['device', 'port'])
        OnosStatsScan.scheme['onos_packetsRxErrors'] = Gauge('onos_packetsRxErrors', 'onos_packetsRxErrors', ['device', 'port'])
        OnosStatsScan.scheme['onos_packetsTxErrors'] = Gauge('onos_packetsTxErrors', 'onos_packetsTxErrors', ['device', 'port'])
        OnosStatsScan.scheme['onos_durationSec'] = Gauge('onos_durationSec', 'onos_durationSec', ['device', 'port'])


    @staticmethod
    def get_data():
        try:
            response = requests.get(OnosStatsScan.config['uri'], auth=auth.HTTPBasicAuth(OnosStatsScan.config['user'], OnosStatsScan.config['password']), timeout=1)
            body =  response.json()['statistics']
            #print body
            for device in body:
                #print device
                for port in device['ports']:
                    OnosStatsScan.scheme['onos_packetsReceived'].labels(device=device['device'], port=port['port']).set(port['packetsReceived'])
                    OnosStatsScan.scheme['onos_packetsSent'].labels(device=device['device'], port=port['port']).set(port['packetsSent'])
                    OnosStatsScan.scheme['onos_bytesReceived'].labels(device=device['device'], port=port['port']).set(port['bytesReceived'])
                    OnosStatsScan.scheme['onos_bytesSent'].labels(device=device['device'], port=port['port']).set(port['bytesSent'])
                    OnosStatsScan.scheme['onos_packetsRxDropped'].labels(device=device['device'], port=port['port']).set(port['packetsRxDropped'])
                    OnosStatsScan.scheme['onos_packetsTxDropped'].labels(device=device['device'], port=port['port']).set(port['packetsTxDropped'])
                    OnosStatsScan.scheme['onos_packetsRxErrors'].labels(device=device['device'], port=port['port']).set(port['packetsRxErrors'])
                    OnosStatsScan.scheme['onos_packetsTxErrors'].labels(device=device['device'], port=port['port']).set(port['packetsTxErrors'])
                    OnosStatsScan.scheme['onos_durationSec'].labels(device=device['device'], port=port['port']).set(port['durationSec'])


        except requests.exceptions.Timeout:
            print "Onos connecion error"
        print 'Onos Stats Scan'

