from prometheus_client import Gauge
import requests
from requests import auth


class VolthaDevicesScan:
    scheme = {}
    config = {}
    db = {}

    def __init__(self):
        pass

    @staticmethod
    def create_scheme(config):
        VolthaDevicesScan.config = config
        VolthaDevicesScan.scheme = {}
        VolthaDevicesScan.scheme['voltha_parent_id'] = Gauge('voltha_parent_id', 'voltha_parent_id', ['id', 'parent_id'])
        VolthaDevicesScan.scheme['voltha_type'] = Gauge('voltha_type', 'voltha_type', ['id', 'type'])
        VolthaDevicesScan.scheme['voltha_admin_state'] = Gauge('voltha_admin_state', 'voltha_admin_state', ['id', 'admin_state'])
        VolthaDevicesScan.scheme['voltha_oper_status'] = Gauge('voltha_oper_status', 'voltha_oper_status', ['id', 'oper_status'])
        VolthaDevicesScan.scheme['voltha_connect_status'] = Gauge('voltha_connect_status', 'voltha_connect_status', ['id', 'connect_status'])

    @staticmethod
    def get_data():
        try:
            response = requests.get(VolthaDevicesScan.config['uri'], auth=auth.HTTPBasicAuth(VolthaDevicesScan.config['user'], VolthaDevicesScan.config['password']), timeout=1)
            body =  response.json()['items']
            #print body
            for id in body:
                VolthaDevicesScan.scheme['voltha_parent_id'].labels(id=id['id'], parent_id=id['parent_id'])
                VolthaDevicesScan.scheme['voltha_type'].labels(id=id['id'], type=id['type'])
                VolthaDevicesScan.scheme['voltha_admin_state'].labels(id=id['id'], admin_state=id['admin_state'])
                VolthaDevicesScan.scheme['voltha_oper_status'].labels(id=id['id'], oper_status=id['oper_status'])
                VolthaDevicesScan.scheme['voltha_connect_status'].labels(id=id['id'], connect_status=id['connect_status'])



        except requests.exceptions.Timeout:
            print "Voltha connecion error"
        print 'Voltha Stats Scan'