/*
 * Copyright 2014 Open Networking Laboratory
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ctpd.olt;

import org.apache.karaf.shell.commands.Argument;
import org.apache.karaf.shell.commands.Command;
import org.onosproject.cli.AbstractShellCommand;

import org.ctpd.olt.api.OltDeviceService;
import org.onosproject.net.DeviceId;


/**
 * A demo service that lists the endpoints for which intents are installed.
 */
@Command(scope = "onos", name = "olt-remove",
        description = "Remove OLT")
public class CtpdOLTRemoveCommand extends AbstractShellCommand {

    @Argument(index = 0, name = "device", description = "Device Id of OLT",
    required = true, multiValued = false)
    private String device = null;


    @Override
    protected void execute() {
        print(get(OltDeviceService.class).removeDevice(DeviceId.deviceId(device)));
    }
}